- Main Page
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# MatlabProgram Class Reference

`#include <matlabprogram.h>`

Inheritance diagram for MatlabProgram:

[legend]
Collaboration diagram for MatlabProgram:

[legend]
List of all members.

## Public Member Functions
| MatlabProgram (const ArrayOfMatrices &x0, const ArrayOfMatrices &lb, const ArrayOfMatrices &ub, const Matrix &constraintlb, const Matrix &constraintub, const MatlabFunctionHandle &objFunc, const MatlabFunctionHandle &gradFunc, const MatlabFunctionHandle &constraintFunc, const MatlabFunctionHandle &jacobianFunc, const MatlabFunctionHandle &hessianFunc, const MatlabFunctionHandle &iterFunc, const mxArray *auxData, ArrayOfMatrices &xsol, bool useQuasiNewton, Multipliers *initialMultipliers=0, Multipliers *multipliers=0)
virtual | ~MatlabProgram ()
char * | geterrormsg () const
int | getnumiterations () const
virtual bool | get_nlp_info (int &numVariables, int &numConstraints, int &sizeOfJ, int &sizeOfH, IndexStyleEnum &indexStyle)
virtual bool | get_bounds_info (int numVariables, double *lbptr, double *ubptr, int numConstraints, double *clbptr, double *cubptr)
| overload this method to return the information about the bound on the variables and constraints.
virtual bool | get_starting_point (int numVariables, bool initializeVars, double *variables, bool initializez, double *zl, double *zu, int numConstraints, bool initializeLambda, double *lambda)
| overload this method to return the starting point.
virtual bool | eval_f (int numVariables, const double *variables, bool ignoreThis, double &objective)
| overload this method to return the value of the objective function
virtual bool | eval_grad_f (int numVariables, const double *variables, bool ignoreThis, double *gradient)
| overload this method to return the vector of the gradient of the objective w.r.t.
virtual bool | eval_g (int numVariables, const double *variables, bool ignoreThis, int numConstraints, double *constraints)
| overload this method to return the vector of constraint values
virtual bool | eval_jac_g (int numVariables, const double *variables, bool ignoreThis, int numConstraints, int sizeOfJ, int *rows, int *cols, double *Jacobian)
| overload this method to return the jacobian of the constraints.
virtual bool | eval_h (int numVariables, const double *variables, bool ignoreThis, double sigma, int numConstraints, const double *multipliers, bool ignoreThisToo, int sizeOfH, int *rows, int *cols, double *Hessian)
| overload this method to return the hessian of the lagrangian.
virtual void | finalize_solution (SolverReturn status, int numVariables, const double *variables, const double *zl, const double *zu, int numConstraints, const double *constraints, const double *lambda, double objective, const IpoptData *ip_data, IpoptCalculatedQuantities *ip_cq)
virtual bool | intermediate_callback (AlgorithmMode mode, int iteration, double objective, double inf_pr, double inf_du, double mu, double d_norm, double regularization_ize, double alpha_du, double alpha_pr, int ls_trials, const IpoptData *ip_data, IpoptCalculatedQuantities *ip_cq)
## Protected Member Functions
| MatlabProgram (const MatlabProgram &source)
MatlabProgram & | operator= (const MatlabProgram &source)
## Protected Attributes
const ArrayOfMatrices & | x0
const ArrayOfMatrices & | lb
const ArrayOfMatrices & | ub
const Matrix & | constraintlb
const Matrix & | constraintub
const mxArray * | auxData
ArrayOfMatrices & | xsol
ArrayOfMatrices * | x
Multipliers * | initialMultipliers
Multipliers * | multipliers
Array< double > * | lambda
int | numiter
mxArray ** | prhs
mxArray * | lambdarhs
bool | useQuasiNewton
SparseMatrixStructure * | JacobianStructure
SparseMatrixStructure * | HessianStructure
const MatlabFunctionHandle & | objFunc
const MatlabFunctionHandle & | gradFunc
const MatlabFunctionHandle & | constraintFunc
const MatlabFunctionHandle & | jacobianFunc
const MatlabFunctionHandle & | hessianFunc
const MatlabFunctionHandle & | iterFunc
## Private Member Functions
double | computeObjective (const ArrayOfMatrices &x)
void | computeGradient (const ArrayOfMatrices &x, ArrayOfMatrices &grad)
void | computeConstraints (const ArrayOfMatrices &x, Array< double > &g)
void | computeJacobian (const ArrayOfMatrices &x, double *Jacobian)
void | computeHessian (const ArrayOfMatrices &x, const Array< double > &lambda, double sigma, double *Hessian)
mxArray * | callMatlabJacobianRoutine (const ArrayOfMatrices &x, bool returnStructureOnly=true)
mxArray * | callMatlabHessianRoutine (const ArrayOfMatrices &x, const Array< double > &lambda, bool returnStructureOnly=true, double sigma=0)

## Detailed Description

Definition at line 30 of file matlabprogram.h.

## Constructor & Destructor Documentation

MatlabProgram::MatlabProgram | ( | const ArrayOfMatrices & | x0,
|  | const ArrayOfMatrices & | lb,
|  | const ArrayOfMatrices & | ub,
|  | const Matrix & | constraintlb,
|  | const Matrix & | constraintub,
|  | const MatlabFunctionHandle & | objFunc,
|  | const MatlabFunctionHandle & | gradFunc,
|  | const MatlabFunctionHandle & | constraintFunc,
|  | const MatlabFunctionHandle & | jacobianFunc,
|  | const MatlabFunctionHandle & | hessianFunc,
|  | const MatlabFunctionHandle & | iterFunc,
|  | const mxArray * | auxData,
|  | ArrayOfMatrices & | xsol,
|  | bool | useQuasiNewton,
|  | Multipliers * | initialMultipliers = `0`,
|  | Multipliers * | multipliers = `0` |
| ) |  |  |

virtual MatlabProgram::~MatlabProgram | ( |  | ) | `[virtual]`

MatlabProgram::MatlabProgram | ( | const MatlabProgram & | source | ) | `[protected]`

## Member Function Documentation

char* MatlabProgram::geterrormsg | ( |  | ) | const

int MatlabProgram::getnumiterations | ( |  | ) | const`[inline]`

Definition at line 57 of file matlabprogram.h.

References numiter.

virtual bool MatlabProgram::get_nlp_info | ( | int & | numVariables,
|  | int & | numConstraints,
|  | int & | sizeOfJ,
|  | int & | sizeOfH,
|  | IndexStyleEnum & | indexStyle |
| ) |  |  | `[virtual]`

virtual bool MatlabProgram::get_bounds_info | ( | int | numVariables,
|  | double * | lbptr,
|  | double * | ubptr,
|  | int | numConstraints,
|  | double * | clbptr,
|  | double * | cubptr |
| ) |  |  | `[virtual]`

overload this method to return the information about the bound on the variables and constraints.

The value that indicates that a bound does not exist is specified in the parameters nlp_lower_bound_inf and nlp_upper_bound_inf. By default, nlp_lower_bound_inf is -1e19 and nlp_upper_bound_inf is 1e19. (see TNLPAdapter)

Implements Ipopt::TNLP.

virtual bool MatlabProgram::get_starting_point | ( | int | numVariables,
|  | bool | initializeVars,
|  | double * | variables,
|  | bool | initializez,
|  | double * | zl,
|  | double * | zu,
|  | int | numConstraints,
|  | bool | initializeLambda,
|  | double * | lambda |
| ) |  |  | `[virtual]`

overload this method to return the starting point.

The bool variables indicate whether the algorithm wants you to initialize x, z_L/z_u, and lambda, respectively. If, for some reason, the algorithm wants you to initialize these and you cannot, return false, which will cause Ipopt to stop. You will have to run Ipopt with different options then.

Implements Ipopt::TNLP.

virtual bool MatlabProgram::eval_f | ( | int | numVariables,
|  | const double * | variables,
|  | bool | ignoreThis,
|  | double & | objective |
| ) |  |  | `[virtual]`

overload this method to return the value of the objective function

Implements Ipopt::TNLP.

virtual bool MatlabProgram::eval_grad_f | ( | int | numVariables,
|  | const double * | variables,
|  | bool | ignoreThis,
|  | double * | gradient |
| ) |  |  | `[virtual]`

overload this method to return the vector of the gradient of the objective w.r.t.

x

Implements Ipopt::TNLP.

virtual bool MatlabProgram::eval_g | ( | int | numVariables,
|  | const double * | variables,
|  | bool | ignoreThis,
|  | int | numConstraints,
|  | double * | constraints |
| ) |  |  | `[virtual]`

overload this method to return the vector of constraint values

Implements Ipopt::TNLP.

virtual bool MatlabProgram::eval_jac_g | ( | int | numVariables,
|  | const double * | variables,
|  | bool | ignoreThis,
|  | int | numConstraints,
|  | int | sizeOfJ,
|  | int * | rows,
|  | int * | cols,
|  | double * | Jacobian |
| ) |  |  | `[virtual]`

overload this method to return the jacobian of the constraints.

The vectors iRow and jCol only need to be set once. The first call is used to set the structure only (iRow and jCol will be non-NULL, and values will be NULL) For subsequent calls, iRow and jCol will be NULL.

Implements Ipopt::TNLP.

virtual bool MatlabProgram::eval_h | ( | int | numVariables,
|  | const double * | variables,
|  | bool | ignoreThis,
|  | double | sigma,
|  | int | numConstraints,
|  | const double * | multipliers,
|  | bool | ignoreThisToo,
|  | int | sizeOfH,
|  | int * | rows,
|  | int * | cols,
|  | double * | Hessian |
| ) |  |  | `[virtual]`

overload this method to return the hessian of the lagrangian.

The vectors iRow and jCol only need to be set once (during the first call). The first call is used to set the structure only (iRow and jCol will be non-NULL, and values will be NULL) For subsequent calls, iRow and jCol will be NULL. This matrix is symmetric - specify the lower diagonal only. A default implementation is provided, in case the user wants to se quasi-Newton approximations to estimate the second derivatives and doesn't not neet to implement this method.

Reimplemented from Ipopt::TNLP.

virtual void MatlabProgram::finalize_solution | ( | SolverReturn | status,
|  | int | numVariables,
|  | const double * | variables,
|  | const double * | zl,
|  | const double * | zu,
|  | int | numConstraints,
|  | const double * | constraints,
|  | const double * | lambda,
|  | double | objective,
|  | const IpoptData * | ip_data,
|  | IpoptCalculatedQuantities * | ip_cq |
| ) |  |  | `[virtual]`

virtual bool MatlabProgram::intermediate_callback | ( | AlgorithmMode | mode,
|  | int | iteration,
|  | double | objective,
|  | double | inf_pr,
|  | double | inf_du,
|  | double | mu,
|  | double | d_norm,
|  | double | regularization_ize,
|  | double | alpha_du,
|  | double | alpha_pr,
|  | int | ls_trials,
|  | const IpoptData * | ip_data,
|  | IpoptCalculatedQuantities * | ip_cq |
| ) |  |  | `[virtual]`

MatlabProgram& MatlabProgram::operator= | ( | const MatlabProgram & | source | ) | `[inline, protected]`

Definition at line 175 of file matlabprogram.h.

double MatlabProgram::computeObjective | ( | const ArrayOfMatrices & | x | ) | `[private]`

void MatlabProgram::computeGradient | ( | const ArrayOfMatrices & | x,
|  | ArrayOfMatrices & | grad |
| ) |  |  | `[private]`

void MatlabProgram::computeConstraints | ( | const ArrayOfMatrices & | x,
|  | Array< double > & | g |
| ) |  |  | `[private]`

void MatlabProgram::computeJacobian | ( | const ArrayOfMatrices & | x,
|  | double * | Jacobian |
| ) |  |  | `[private]`

void MatlabProgram::computeHessian | ( | const ArrayOfMatrices & | x,
|  | const Array< double > & | lambda,
|  | double | sigma,
|  | double * | Hessian |
| ) |  |  | `[private]`

mxArray* MatlabProgram::callMatlabJacobianRoutine | ( | const ArrayOfMatrices & | x,
|  | bool | returnStructureOnly = `true` |
| ) |  |  | `[private]`

mxArray* MatlabProgram::callMatlabHessianRoutine | ( | const ArrayOfMatrices & | x,
|  | const Array< double > & | lambda,
|  | bool | returnStructureOnly = `true`,
|  | double | sigma = `0` |
| ) |  |  | `[private]`

## Member Data Documentation

const ArrayOfMatrices& MatlabProgram::x0`[protected]`

Definition at line 128 of file matlabprogram.h.

const ArrayOfMatrices& MatlabProgram::lb`[protected]`

Definition at line 129 of file matlabprogram.h.

const ArrayOfMatrices& MatlabProgram::ub`[protected]`

Definition at line 130 of file matlabprogram.h.

const Matrix& MatlabProgram::constraintlb`[protected]`

Definition at line 131 of file matlabprogram.h.

const Matrix& MatlabProgram::constraintub`[protected]`

Definition at line 132 of file matlabprogram.h.

const mxArray* MatlabProgram::auxData`[protected]`

Definition at line 133 of file matlabprogram.h.

ArrayOfMatrices& MatlabProgram::xsol`[protected]`

Definition at line 135 of file matlabprogram.h.

ArrayOfMatrices* MatlabProgram::x`[protected]`

Definition at line 136 of file matlabprogram.h.

Multipliers* MatlabProgram::initialMultipliers`[protected]`

Definition at line 139 of file matlabprogram.h.

Multipliers* MatlabProgram::multipliers`[protected]`

Definition at line 141 of file matlabprogram.h.

Array<double>* MatlabProgram::lambda`[protected]`

Definition at line 144 of file matlabprogram.h.

int MatlabProgram::numiter`[protected]`

Definition at line 148 of file matlabprogram.h.

Referenced by getnumiterations().

mxArray** MatlabProgram::prhs`[protected]`

Definition at line 152 of file matlabprogram.h.

mxArray* MatlabProgram::lambdarhs`[protected]`

Definition at line 153 of file matlabprogram.h.

bool MatlabProgram::useQuasiNewton`[protected]`

Definition at line 156 of file matlabprogram.h.

SparseMatrixStructure* MatlabProgram::JacobianStructure`[protected]`

Definition at line 161 of file matlabprogram.h.

SparseMatrixStructure* MatlabProgram::HessianStructure`[protected]`

Definition at line 162 of file matlabprogram.h.

const MatlabFunctionHandle& MatlabProgram::objFunc`[protected]`

Definition at line 165 of file matlabprogram.h.

const MatlabFunctionHandle& MatlabProgram::gradFunc`[protected]`

Definition at line 166 of file matlabprogram.h.

const MatlabFunctionHandle& MatlabProgram::constraintFunc`[protected]`

Definition at line 167 of file matlabprogram.h.

const MatlabFunctionHandle& MatlabProgram::jacobianFunc`[protected]`

Definition at line 168 of file matlabprogram.h.

const MatlabFunctionHandle& MatlabProgram::hessianFunc`[protected]`

Definition at line 169 of file matlabprogram.h.

const MatlabFunctionHandle& MatlabProgram::iterFunc`[protected]`

Definition at line 170 of file matlabprogram.h.

The documentation for this class was generated from the following file:

- /home/coin/SVN-release/Ipopt-3.5.1/Ipopt/contrib/MatlabInterface/src/matlabprogram.h